/* 
 * @(#)OrderSupplyServices.java       04:31:56 PM 2003/02/21
 *
 * This class will read the host information from 
 * the web.xml of the deployed webapp.
 * To set those information, please refer to the documentation, 
 * 
 */ 

import java.math.*;
import com.ibm.connector.as400.*;


public class OrderSupplyServices extends ProgramCallBean
{

  public OrderSupplyServices()
  {
    super();
    WebIntRuntimeConfig rtCfg = new WebIntRuntimeConfig( "OrderSupply", this );
    String[] connData = rtCfg.getHostConnectionInfo();
    setPcmlName("OrderSupply");
    setLibraryList( rtCfg.getLibraryList() );
    setConnectionData( connData[0], connData[1], connData[2] );
    setTraceEnabled( false );
  }


	public String OrderSupply_XML(
		BigDecimal ItemNo,
		BigDecimal Quantity,
		String Size) {
		setProgramName("OrderSupply");
		setValue("OrderSupply.ItemNo", ItemNo);
		setValue("OrderSupply.Quantity", Quantity);
		setValue("OrderSupply.Size", Size);
		invoke();
		String strResult = process_OrderSupply_Output_XML();
		return strResult;
	}

	public OrderSupplyResult OrderSupply(
		BigDecimal ItemNo,
		BigDecimal Quantity,
		String Size) {
		setProgramName("OrderSupply");
		setValue("OrderSupply.ItemNo", ItemNo);
		setValue("OrderSupply.Quantity", Quantity);
		setValue("OrderSupply.Size", Size);
		invoke();
		OrderSupplyResult result = process_OrderSupply_Output();
		return result;
	}

	public OrderSupplyResult OrderSupply(OrderSupplyInput inputData) {
		HandleInput(inputData);
		invoke();
		OrderSupplyResult result = process_OrderSupply_Output();
		return result;
	}
	public String OrderSupply_XML(OrderSupplyInput inputData) {
		HandleInput(inputData);
		invoke();
		String strResult = process_OrderSupply_Output_XML();
		return strResult;
	}
	private void HandleInput(OrderSupplyInput inputData) {
		setProgramName("OrderSupply");
		int[] idx = null;
		setValue("OrderSupply.ItemNo", idx, inputData.getItemNo());
		setValue("OrderSupply.Quantity", idx, inputData.getQuantity());
		setValue("OrderSupply.Size", idx, inputData.getSize());
	}
	private int[] addidx(int[] arg, int arg2) {
		int[] toReturn;
		if (arg == null) {
			toReturn = new int[] { arg2 };
			return toReturn;
		}
		toReturn = new int[arg.length + 1];
		for (int i = 0; i < arg.length; i++) {
			toReturn[i] = arg[i];
		}
		toReturn[toReturn.length - 1] = arg2;
		return toReturn;
	}
	private int[] removeidx(int[] arg) {
		if (arg.length == 1)
			return null;
		int[] toReturn = new int[arg.length - 1];
		for (int i = 0; i < toReturn.length; i++) {
			toReturn[i] = arg[i];
		}
		return toReturn;
	}

	private String process_OrderSupply_Output_XML() {
		StringBuffer strResult = new StringBuffer();
		int[] idx = null;
		strResult.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		strResult.append("<OrderSupply>\n");
		strResult.append(
			"  <ReturnCode>"
				+ getData("OrderSupply.ReturnCode", ProgramCallBean.STRING, idx)
				+ "</ReturnCode>\n");
		strResult.append(
			"  <Price>"
				+ getData("OrderSupply.Price", ProgramCallBean.BIGDECIMAL, idx)
				+ "</Price>\n");
		strResult.append("</OrderSupply>\n");
		return strResult.toString();
	}

	private OrderSupplyResult process_OrderSupply_Output() {
		int[] idx = null;
		OrderSupplyResult result = new OrderSupplyResult();
		result.setReturnCode((String) getValue("OrderSupply.ReturnCode"));
		result.setPrice((BigDecimal) getValue("OrderSupply.Price"));
		return result;
	}


}
