/* 
 * @(#)OrderSupplyServices.java       02:07:19 PM 2002/05/17
 *
 * This class will read the host information from 
 * the web.xml of the deployed webapp.
 * To set those information, please refer to the documentation, 
 * 
 */ 
package order;


import java.math.*;
import com.ibm.connector.as400.*;


public class OrderSupplyServices extends ProgramCallBean
{

  public OrderSupplyServices()
  {
    super();
    WebIntRuntimeConfig rtCfg = new WebIntRuntimeConfig( "OrderSupply", this );
    String[] connData = rtCfg.getHostConnectionInfo();
    setPcmlName("OrderSupply");
    setLibraryList( rtCfg.getLibraryList() );
    setConnectionData( connData[0], connData[1], connData[2] );
    setTraceEnabled( false );
  }


  public String OrderSupply_XML(BigDecimal ItemNo, BigDecimal Quantity, String Size)
  {
    setProgramName("OrderSupply");
    setValue( "OrderSupply.ItemNo",ItemNo);
    setValue( "OrderSupply.Quantity",Quantity);
    setValue( "OrderSupply.Size",Size);
    invoke();
    String strResult = process_OrderSupply_Output_XML();
    return strResult;
  }

  public OrderSupplyResult OrderSupply(BigDecimal ItemNo, BigDecimal Quantity, String Size)
  {
    setProgramName("OrderSupply");
    setValue( "OrderSupply.ItemNo",ItemNo);
    setValue( "OrderSupply.Quantity",Quantity);
    setValue( "OrderSupply.Size",Size);
    invoke();
    OrderSupplyResult result = process_OrderSupply_Output();
    return result;
  }


  private String process_OrderSupply_Output_XML()
  {
    StringBuffer strResult = new StringBuffer();
    strResult.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
    strResult.append("<OrderSupply>\n");
    strResult.append("  <ReturnCode>" + getData("OrderSupply.ReturnCode", ProgramCallBean.STRING) + "</ReturnCode>\n");
    strResult.append("  <Price>" + getData("OrderSupply.Price", ProgramCallBean.BIGDECIMAL) + "</Price>\n");
    strResult.append("</OrderSupply>\n");
    return strResult.toString();
  }

  private OrderSupplyResult process_OrderSupply_Output()
  {
    OrderSupplyResult result = new OrderSupplyResult();
    result.setReturnCode( (String)getValue("OrderSupply.ReturnCode") );
    result.setPrice( (BigDecimal)getValue("OrderSupply.Price") );
    return result;
  }



}
